OGRE-Next: Ogre::NULLVaoManager Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | List of all members
Ogre::NULLVaoManager Class Reference

`#include <OgreNULLVaoManager.h>`

Inheritance diagram for Ogre::NULLVaoManager:
[legend]

## Classes
struct | Block
struct | StrideChanger

## Public Types
typedef vector< Block >::type | BlockVec
typedef vector< StrideChanger >::type | StrideChangerVec
Public Types inherited from Ogre::VaoManager
typedef vector< MemoryStatsEntry >::type | MemoryStatsEntryVec

## Public Member Functions
| NULLVaoManager ()
| ~NULLVaoManager () override
void | _update () override
void | cleanupEmptyPools () override
| Frees GPU memory if there are empty, unused pools.
AsyncTicketPtr | createAsyncTicket (BufferPacked *creator, StagingBuffer *stagingBuffer, size_t elementStart, size_t elementCount) override
StagingBuffer * | createStagingBuffer (size_t sizeBytes, bool forUpload) override
| Creates a new staging buffer and adds it to the pool.
void | getMemoryStats (MemoryStatsEntryVec &outStats, size_t &outCapacityBytes, size_t &outFreeBytes, Log *log, bool &outIncludesTextures) const override
| Retrieves memory stats about our GPU pools being managed.
bool | isFrameFinished (uint32 frameCount) override
| If this returns true, then waitForSpecificFrameToFinish is guaranteed to return immediately.
bool | supportsArbBufferStorage () const
void | waitForSpecificFrameToFinish (uint32 frameCount) override
| Waits for a specific frame to be ready.
uint8 | waitForTailFrameToFinish () override
| Returns the current frame # (which wraps to 0 every mDynamicBufferMultiplier times).
Public Member Functions inherited from Ogre::VaoManager
| VaoManager (const NameValuePairList *params)
virtual | ~VaoManager ()
virtual void | _beginFrame ()
uint8 | _getDynamicBufferCurrentFrameNoWait () const
void | _notifyStagingBufferEnteredZeroRef (StagingBuffer *stagingBuffer)
void | _notifyStagingBufferLeftZeroRef (StagingBuffer *stagingBuffer)
virtual void | _waitUntilCommitedCommandBufferCompleted ()
| Waits for the last committed command buffer completion instead of the last frame completion with command buffer switching, so we can continue to work with current command buffer.
ConstBufferPacked * | createConstBuffer (size_t sizeBytes, BufferType bufferType, void *initialData, bool keepAsShadow)
| Creates an constant buffer based on the given parameters.
IndexBufferPacked * | createIndexBuffer (IndexBufferPacked::IndexType indexType, size_t numIndices, BufferType bufferType, void *initialData, bool keepAsShadow)
| Creates an index buffer based on the given parameters.
IndirectBufferPacked * | createIndirectBuffer (size_t sizeBytes, BufferType bufferType, void *initialData, bool keepAsShadow)
| Creates an indirect buffer.
ReadOnlyBufferPacked * | createReadOnlyBuffer (PixelFormatGpu pixelFormat, size_t sizeBytes, BufferType bufferType, void *initialData, bool keepAsShadow)
| Creates a read-only buffer based on the given parameters.
TexBufferPacked * | createTexBuffer (PixelFormatGpu pixelFormat, size_t sizeBytes, BufferType bufferType, void *initialData, bool keepAsShadow)
| Creates an constant buffer based on the given parameters.
UavBufferPacked * | createUavBuffer (size_t numElements, uint32 bytesPerElement, uint32 bindFlags, void *initialData, bool keepAsShadow)
| Creates an UAV buffer based on the given parameters.
VertexArrayObject * | createVertexArrayObject (const VertexBufferPackedVec &vertexBuffers, IndexBufferPacked *indexBuffer, OperationType opType)
| Creates a VertexArrayObject that binds all the vertex buffers with their respective declarations, and the index buffers.
VertexBufferPacked * | createVertexBuffer (const VertexElement2Vec &vertexElements, size_t numVertices, BufferType bufferType, void *initialData, bool keepAsShadow)
| Creates a vertex buffer based on the given parameters.
void | deleteStagingBuffers ()
void | destroyConstBuffer (ConstBufferPacked *constBuffer)
| Destroys the given constant buffer created with createConstBuffer.
void | destroyIndexBuffer (IndexBufferPacked *indexBuffer)
| Destroys the given index buffer created with createIndexBuffer.
void | destroyIndirectBuffer (IndirectBufferPacked *indirectBuffer)
| Destroys the given indirect buffer created with createIndirectBuffer.
void | destroyReadOnlyBuffer (ReadOnlyBufferPacked *readOnlyBuffer)
| Destroys the given texture buffer created with createReadOnlyBuffer.
void | destroyTexBuffer (TexBufferPacked *texBuffer)
| Destroys the given texture buffer created with createTexBuffer.
void | destroyUavBuffer (UavBufferPacked *uavBuffer)
| Destroys the given UAV buffer created with createUavBuffer.
void | destroyVertexArrayObject (VertexArrayObject *vao)
| Destroys the input pointer.
void | destroyVertexBuffer (VertexBufferPacked *vertexBuffer)
| Destroys the given vertex buffer created with createVertexBuffer.
uint32 | getConstBufferAlignment () const
size_t | getConstBufferMaxSize () const
uint32 | getDefaultStagingBufferLifetime () const
uint32 | getDefaultStagingBufferUnfencedTime () const
uint8 | getDynamicBufferMultiplier () const
uint32 | getFrameCount ()
size_t | getReadOnlyBufferMaxSize () const
StagingBuffer * | getStagingBuffer (size_t minSizeBytes, bool forUpload)
| Retrieves a staging buffer for use.
uint32 | getTexBufferAlignment () const
size_t | getTexBufferMaxSize () const
Timer * | getTimer ()
uint32 | getUavBufferAlignment () const
size_t | getUavBufferMaxSize () const
bool | readOnlyIsTexBuffer () const
| When true, ReadOnlyBufferPacked behaves like TexBufferPacked, i.e.
void | setDefaultStagingBufferlifetime (uint32 lifetime, uint32 unfencedTime)
| Sets the default time for staging buffers.
bool | supportsBaseInstance () const
bool | supportsIndirectBuffers () const
| When false, IndirectBufferPacked will emulate the mapping behavior, and we need to use the emulated calls in RenderSystem.
bool | supportsPersistentMapping () const

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::VaoManager
static uint32 | calculateVertexSize (const VertexElement2Vec &vertexElements)
| Returns the size of a single vertex buffer source with the given declaration, in bytes.

## Member Typedef Documentation

## ◆ BlockVec

typedef vector<Block>::type Ogre::NULLVaoManager::BlockVec

## ◆ StrideChangerVec

typedef vector<StrideChanger>::type Ogre::NULLVaoManager::StrideChangerVec

## Constructor & Destructor Documentation

## ◆ NULLVaoManager()

Ogre::NULLVaoManager::NULLVaoManager | ( |  | ) |

## ◆ ~NULLVaoManager()

Ogre::NULLVaoManager::~NULLVaoManager | ( |  | ) |
| override

## Member Function Documentation

## ◆ _update()

void Ogre::NULLVaoManager::_update | ( |  | ) |
| overridevirtual

Reimplemented from Ogre::VaoManager.

## ◆ cleanupEmptyPools()

void Ogre::NULLVaoManager::cleanupEmptyPools | ( |  | ) |
| overridevirtual

Frees GPU memory if there are empty, unused pools.

Implements Ogre::VaoManager.

## ◆ createAsyncTicket()

AsyncTicketPtr Ogre::NULLVaoManager::createAsyncTicket | ( | BufferPacked * | creator,
|  | StagingBuffer * | stagingBuffer,
|  | size_t | elementStart,
|  | size_t | elementCount )
| overridevirtual

Implements Ogre::VaoManager.

## ◆ createStagingBuffer()

StagingBuffer * Ogre::NULLVaoManager::createStagingBuffer | ( | size_t | sizeBytes,
|  | bool | forUpload )
| overridevirtual

Creates a new staging buffer and adds it to the pool.

See also
  getStagingBuffer.

Remarks
  The returned buffer starts with a reference count of 1. You should decrease it when you're done using it.

Implements Ogre::VaoManager.

## ◆ getMemoryStats()

void Ogre::NULLVaoManager::getMemoryStats | ( | MemoryStatsEntryVec & | outStats,
|  | size_t & | outCapacityBytes,
|  | size_t & | outFreeBytes,
|  | Log * | log,
|  | bool & | outIncludesTextures ) const
| overridevirtual

Retrieves memory stats about our GPU pools being managed.

The output in the Log will be csv data that resembles the following: Pool Type Offset Bytes Pool Capacity CPU_INACCESSIBLE 0 148128 67108864 CPU_INACCESSIBLE 200000 1024 67108864 CPU_ACCESSIBLE_PERSISTENT 0 1152 16777216

These are the chunks of memory currently in use. If there are multiple entries belonging to the same pool, that means the memory has been fragmented.

The actual output may vary depending on the RenderSystem.

Remarks
  Worst case scenario this function has O(N^2) complexity where N is the number of free blocks.

Parameters

  outStats | Detailed information about each entry.
  outCapacityBytes | Total capacity i.e. total used VRAM in GPU.
  outFreeBytes | Total free memory available for consumption.
  log | Optional to dump all information to a CSV file. Nullptr to avoid dumping.
  outIncludesTextures | [out] When true, memory reports in outCapacityBytes & outFreeBytes include textures. See Tutorial_Memory on how to deal with this output.

Note outIncludesTextures may be false but some entries in outStats[n].bPoolHasTextures may be true. If this happens, then outCapacityBytes & outFreeBytes don't include texture consumption; but the pools with bPoolHasTextures in MemoryStatsEntryVec may.

Implements Ogre::VaoManager.

## ◆ isFrameFinished()

bool Ogre::NULLVaoManager::isFrameFinished | ( | uint32 | frameCount | ) |
| overridevirtual

If this returns true, then waitForSpecificFrameToFinish is guaranteed to return immediately.

Implements Ogre::VaoManager.

## ◆ supportsArbBufferStorage()

bool Ogre::NULLVaoManager::supportsArbBufferStorage | ( |  | ) | const
| inline

## ◆ waitForSpecificFrameToFinish()

void Ogre::NULLVaoManager::waitForSpecificFrameToFinish | ( | uint32 | frameCount | ) |
| overridevirtual

Waits for a specific frame to be ready.

Calling waitForSpecificFrameToFinish( mFrameCount - mDynamicBufferMultiplier ) equals to calling waitForTailFrameToFinish.

Remarks
  WARNING: calling waitForSpecificFrameToFinish( mFrameCount ); will perform a full stall!

  Avoid calling this function. Some implementations may decide to always full stall unless (mFrameCount - frameCount) >= mDynamicBufferMultiplier

Implements Ogre::VaoManager.

## ◆ waitForTailFrameToFinish()

uint8 Ogre::NULLVaoManager::waitForTailFrameToFinish | ( |  | ) |
| overridevirtual

Returns the current frame # (which wraps to 0 every mDynamicBufferMultiplier times).

But first stalls until that mDynamicBufferMultiplier-1 frame behind is finished.

Implements Ogre::VaoManager.

The documentation for this class was generated from the following file:

- OgreNULLVaoManager.h